#ifndef AUDIOMANIMPL_H
#define AUDIOMANIMPL_H
#include <Wt/WApplication>
#include <Wt/WTemplate>
#include <Wt/WContainerWidget>
#include <Wt/WViewWidget>
#include <Wt/WComboBox>
#include <Wt/WAudio>
#include <Wt/WText>
#include <boost/algorithm/string.hpp>
#include "model/AudioManSession.h"
#include "WidgetFunction.h"
/* ****************************************************************************
 * Audio Man Implementation
 */
class AudioManImpl : public Wt::WContainerWidget
{
    public:
        AudioManImpl(const std::string& basePath);
        void SetInternalBasePath(const std::string& basePath);
        virtual ~AudioManImpl();
        /* --------------------------------------------------------------------
         * session
         */
        AudioManSession& session()  { return session_;  }
        //
        WidgetFunction widgetFunction;
    private:
        // Init in constructor
        std::string basePath_;
        AudioManSession session_;
        //
        Wt::WContainerWidget* items_ = NULL;
        //
        void refresh();
        void ComboboxChanged();
        //
        Wt::WWidget* WrapView(Wt::WWidget *(AudioManImpl::*createWidget)());
        Wt::WWidget* GetTemplate();
        Wt::WWidget*  CreateAudio(int number);
        Wt::WComboBox* cb = NULL;
        Wt::WContainerWidget* audioItems = NULL;
        Wt::WString TextPageBottomDiv;
        //
        bool useTemplate = true;
        int useWidgetFun = true;
        int useTemplateData = 0;
};
#endif // AUDIOMANIMPL_H
// --- End Of File ------------------------------------------------------------
